
//  File:     Computer.cpp
//  Project:  MP3's --- Week 6 HW from Spring 2002
//  Author:   Chuck Stewart
//
//  Purpose:  Implementation of the Computer class

#include <iostream>
using std::cout;
using std::endl;

#include "Computer.h"


//  Constructor:  automatically initializes list of MP3s to be empty.

Computer :: Computer( double speed )
  : speed_( speed )
{ 
}


//  Add an MP3 to the list of MP3s.  Return false if the song is
//  already there.  Return true if the song was not there and hence
//  was added. 

bool 
Computer :: add_mp3( string const& artist, 
		     string const& title,
		     double size )
{
  //  Find the song.  The generic find function is not used here.
  //  Using it would require creating an MP3 object and having an
  //  operator== on the objects.

  list<MP3>::iterator p;
  for ( p = mp3s_.begin(); p != mp3s_.end(); ++p )
    {
      if ( p->get_artist() == artist && p->get_title() == title )
	break;
    }

  if ( p != mp3s_.end() ) 
    {
      return false;
    }
  else
    {
      mp3s_ . push_back( MP3( artist, title, size, size / speed_) );
      return true;
    }
}


//  Iterate through the list of MP3, printing each.

void 
Computer :: print_mp3s() const
{
  for( list<MP3> :: const_iterator p = mp3s_.begin(); p != mp3s_.end(); ++p )
    {
      cout << "\n"
	   << "ARTIST: " << p -> get_artist() << "\n"
	   << "TITLE: " << p -> get_title() << "\n"
	   << "ACCESS: " << p -> get_access_time() << "\n";
    }
}


//  Determine if the Computer has the requested song.  Return true if
//  so and fill in the MP3 parameter.

bool 
Computer :: has_song( string const& artist, string const& title,
		      MP3& requested_song ) const
{
  for ( list<MP3> :: const_iterator p = mp3s_.begin(); p != mp3s_.end(); ++p )
    {
      if ( p->get_artist() == artist && p->get_title() == title )
	{
	  requested_song = *p;
	  return true;
	}
    }
  return false;
}


//  Build a list of all songs by the indicated artist.

list<MP3>
Computer :: songs_by_artist( string const& artist ) const
{
  list<MP3> results;
  for( list<MP3> :: const_iterator p = mp3s_.begin(); p != mp3s_.end(); ++p )
    {
      if ( p -> get_artist() == artist )
	results . push_back( *p );
    }
  return results;
}

