
//  File:     Computer.h
//  Project:  MP3's --- Week 6 HW from Spring 2002
//  Author:   Chuck Stewart
//  
//  Discussion:  The declaration of the Computer class for the MP3
//    project.  Each computer has the capability of adding an MP3
//    file, printing its own MP3 files, determining if a song MP3 is on
//    the computer, or finding the songs by a given artist.  Each Song
//    is a separate object. 
//
//    Note that in a real application this class would be lot more
//    sophisticated.

#ifndef Computer_h_
#define Computer_h_

#include <list>
#include <string>

using std::list;
using std::string;

#include "MP3.h"

class Computer {
public:
  Computer( double speed );

  bool add_mp3( string const& artist, string const& title, double size );
  void print_mp3s() const;
  bool has_song( string const& artist, string const& title,
		 MP3& requested_song ) const;
  list<MP3> songs_by_artist( string const& artist ) const;

private:
  double speed_;           // network connection speed in bytes per second
  list< MP3 > mp3s_;      // the songs on the computer; could be a
                           // vector just as easily
};


#endif
