
//  File:     MP3.h
//  Project:  MP3's --- Week 6 HW from Spring 2002
//  Author:   Chuck Stewart
//  
//  Discussion:  The declaration and implementation of the MP3 class
//    for the MP3 project.  Notice that the MP3 class contains the
//    access time in addition to the file size.  This is somewhat
//    redundant, but makes several of the operations in searching
//    for MP3s and artists simpler.

#ifndef MP3_h_
#define MP3_h_

#include <string>
using std::string;

class MP3 {
public:
  MP3() {}
  MP3( string const& artist, string const& title, double file_size,
       double access_time )
    : artist_(artist), title_(title), file_size_(file_size),
      access_time_(access_time)
  {}

  const string& get_artist() const { return artist_; }
  const string& get_title() const { return title_; }
  double get_size() const { return file_size_; }
  double get_access_time() const { return access_time_; }
  
private:
  string artist_;
  string title_;
  double file_size_;
  double access_time_;
};



#endif
